/*
Code automatically generated by asn1scc tool
*/
#include <limits.h>
#include <string.h>
#include <math.h>
#include "Power.h"

#if !defined(_MSC_VER) || _MSC_VER >= 1800
void PowerMask_Initialize(PowerMask* pVal)
{
    *pVal = (PowerMask) {    .arr = 
    {
        FALSE        
    }
};
}
#endif

 
flag PowerMask_IsConstraintValid(const PowerMask* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	int i1=0;
	*pErrCode=0;

	(void)pVal;

	ret = TRUE; *pErrCode = 0;
	i1 = 0;
	while (ret && (i1< 16)) {
	    ret = T_Boolean_IsConstraintValid(&pVal->arr[i1], pErrCode);
	    i1 = i1+1;
	}

	return ret;
}

flag PowerMask_Encode(const PowerMask* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
	int i1=0;
    
	ret = bCheckConstraints ? PowerMask_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    	
	    for(i1=0; (i1 < (int)16) && ret; i1++) 
	    {
	    	ret = T_Boolean_Encode(&pVal->arr[i1], pBitStrm, pErrCode, FALSE);
	    }
    }

	return ret;
}

flag PowerMask_Decode(PowerMask* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;
	int i1=0;

		
	for(i1=0; (i1 < (int)16) && ret; i1++) 
	{
		ret = T_Boolean_Decode(&pVal->arr[i1], pBitStrm, pErrCode);
	}

	return ret;
}
#if !defined(_MSC_VER) || _MSC_VER >= 1800
void PowerOutput_Initialize(PowerOutput* pVal)
{
    *pVal = (PowerOutput) 1;
}
#endif

 
flag PowerOutput_IsConstraintValid(const PowerOutput* pVal, int* pErrCode)
{
    
    flag ret = TRUE;
	*pErrCode=0;

	(void)pVal;

	ret = (1 <= *pVal && *pVal <= 16);
	*pErrCode = ret ? 0 : ERR_PowerOutput;

	return ret;
}

flag PowerOutput_Encode(const PowerOutput* pVal, BitStream* pBitStrm, int* pErrCode, flag bCheckConstraints)
{
    flag ret = TRUE;
    
	ret = bCheckConstraints ? PowerOutput_IsConstraintValid(pVal, pErrCode) : TRUE ;
	if (ret) {
	    BitStream_EncodeConstraintPosWholeNumber(pBitStrm, *pVal, 1, 16);
    }

	return ret;
}

flag PowerOutput_Decode(PowerOutput* pVal, BitStream* pBitStrm, int* pErrCode)
{
    flag ret = TRUE;

	ret = BitStream_DecodeConstraintPosWholeNumber(pBitStrm, pVal, 1, 16);
	*pErrCode = ret ? 0 : 273940481;

	return ret;
}

